ui_nodes = [
    {
        "id": "0",
        "type": "startNode",
        "data": {"nodeId": "0", "nodeName": "start", "nodePrompt": "start node"},
        "style": {"width": 100, "height": 100},
        "position": {"x": -327.5, "y": 6.5},
        "width": 100,
        "height": 100,
        "selected": False,
        "positionAbsolute": {"x": -327.5, "y": 6.5},
        "dragging": False,
    },
    {
        "id": "1",
        "type": "promptNode",
        "data": {
            "nodeId": "1",
            "nodeName": "message-1",
            "nodePrompt": "greet user",
            "condition": {"properties": {"tag_name": "", "tag_id": ""}},
        },
        "style": {"width": 167.22, "height": 222.95999999999998},
        "position": {"x": -186.5, "y": -18.5},
        "width": 167,
        "height": 223,
        "selected": False,
        "positionAbsolute": {"x": -186.5, "y": -18.5},
        "dragging": False,
    },
    {
        "id": "2",
        "type": "promptNode",
        "data": {
            "nodeId": "2",
            "nodeName": "message-2",
            "nodePrompt": "Ask user what he thinks about now",
            "condition": {"properties": {"tag_name": "", "tag_id": ""}},
        },
        "style": {"width": 167.22, "height": 222.95999999999998},
        "position": {"x": 38.5, "y": -28.5},
        "width": 167,
        "height": 223,
        "selected": True,
        "positionAbsolute": {"x": 38.5, "y": -28.5},
        "dragging": False,
    },
    {
        "id": "3",
        "type": "conditionBlock",
        "data": {
            "nodeId": "3",
            "nodeName": "condition-3",
            "nodePrompt": "",
            "condition": {"properties": {"tag_name": "", "tag_id": ""}},
            "headerHeight": 16,
            "borderWidth": 2,
        },
        "style": {"width": 167.22, "height": 122.19},
        "position": {"x": 269.5, "y": -17.5},
        "positionAbsolute": {"x": 269.5, "y": -17.5},
        "width": 167,
        "height": 122,
        "selected": False,
        "dragging": False,
    },
    {
        "id": "4",
        "type": "singleCondition",
        "data": {
            "nodeId": "4",
            "nodeName": "",
            "nodePrompt": "",
            "condition": {
                "properties": {"tag_name": "", "tag_id": ""},
                "type": "else",
                "attachedNodeId": "4",
            },
            "parentId": "3",
        },
        "style": {"width": 150.498, "height": 27.87},
        "position": {"x": 8.361, "y": 22.645},
        "draggable": False,
        "parentId": "3",
        "extent": "parent",
        "width": 150,
        "height": 28,
        "positionAbsolute": {"x": 277.861, "y": 5.145},
    },
    {
        "id": "5",
        "type": "singleCondition",
        "data": {
            "nodeId": "5",
            "nodeName": "",
            "nodePrompt": "",
            "condition": {
                "properties": {
                    "tag_name": "negative",
                    "tag_id": "5c3e8a6a-944a-4c66-97ed-599446202160",
                },
                "type": "tag_detected",
                "attachedNodeId": "5",
            },
            "parentId": "3",
        },
        "style": {"width": 150.498, "height": 27.87},
        "position": {"x": 8.361, "y": 55.16},
        "draggable": False,
        "parentId": "3",
        "extent": "parent",
        "width": 150,
        "height": 28,
        "positionAbsolute": {"x": 277.861, "y": 37.66},
        "selected": False,
    },
    {
        "id": "6",
        "type": "singleCondition",
        "data": {
            "nodeId": "6",
            "nodeName": "",
            "nodePrompt": "",
            "condition": {
                "properties": {
                    "tag_name": "positive",
                    "tag_id": "e923a0fa-7cac-4715-9b5a-930b0611a71d",
                },
                "type": "tag_detected",
                "attachedNodeId": "6",
            },
            "parentId": "3",
        },
        "style": {"width": 150.498, "height": 27.87},
        "position": {"x": 8.361, "y": 87.675},
        "draggable": False,
        "parentId": "3",
        "extent": "parent",
        "width": 150,
        "height": 28,
        "positionAbsolute": {"x": 277.861, "y": 70.175},
        "selected": False,
    },
    {
        "id": "7",
        "type": "conditionBlock",
        "data": {
            "nodeId": "7",
            "nodeName": "condition-7",
            "nodePrompt": "",
            "condition": {"properties": {"tag_name": "", "tag_id": ""}},
            "headerHeight": 16,
            "borderWidth": 2,
        },
        "style": {"width": 167.22, "height": 89.675},
        "position": {"x": 513, "y": 7},
        "positionAbsolute": {"x": 513, "y": 7},
        "width": 167,
        "height": 90,
        "selected": False,
        "dragging": False,
    },
    {
        "id": "8",
        "type": "singleCondition",
        "data": {
            "nodeId": "8",
            "nodeName": "",
            "nodePrompt": "",
            "condition": {
                "properties": {"tag_name": "", "tag_id": ""},
                "type": "else",
                "attachedNodeId": "8",
            },
            "parentId": "7",
        },
        "style": {"width": 150.498, "height": 27.87},
        "position": {"x": 8.361, "y": 22.645},
        "draggable": False,
        "parentId": "7",
        "extent": "parent",
        "width": 150,
        "height": 28,
        "positionAbsolute": {"x": 521.361, "y": 29.645},
    },
    {
        "id": "9",
        "type": "singleCondition",
        "data": {
            "nodeId": "9",
            "nodeName": "",
            "nodePrompt": "",
            "condition": {
                "properties": {
                    "tag_name": "unsubscribe",
                    "tag_id": "556c7040-3d43-44ef-b1e8-e4548c0f3c1d",
                },
                "type": "tag_detected",
                "attachedNodeId": "9",
            },
            "parentId": "7",
        },
        "style": {"width": 150.498, "height": 27.87},
        "position": {"x": 8.361, "y": 55.16},
        "draggable": False,
        "parentId": "7",
        "extent": "parent",
        "width": 150,
        "height": 28,
        "positionAbsolute": {"x": 521.361, "y": 62.16},
    },
    {
        "id": "10",
        "type": "promptNode",
        "data": {
            "nodeId": "10",
            "nodeName": "message-10",
            "nodePrompt": "wish user a wonderful day and say bye",
            "condition": {"properties": {"tag_name": "", "tag_id": ""}},
        },
        "style": {"width": 167.22, "height": 222.95999999999998},
        "position": {"x": 671, "y": 171.5},
        "width": 167,
        "height": 223,
        "selected": False,
        "positionAbsolute": {"x": 671, "y": 171.5},
        "dragging": False,
    },
    {
        "id": "11",
        "type": "promptNode",
        "data": {
            "nodeId": "11",
            "nodeName": "message-11",
            "nodePrompt": "say user he was unsubscribed",
            "condition": {"properties": {"tag_name": "", "tag_id": ""}},
        },
        "style": {"width": 167.22, "height": 222.95999999999998},
        "position": {"x": 905.5, "y": 100.5},
        "width": 167,
        "height": 223,
        "selected": False,
        "positionAbsolute": {"x": 905.5, "y": 100.5},
        "dragging": False,
    },
    {
        "id": "12",
        "type": "promptNode",
        "data": {
            "nodeId": "12",
            "nodeName": "message-12",
            "nodePrompt": "say user bye",
            "condition": {"properties": {"tag_name": "", "tag_id": ""}},
        },
        "style": {"width": 167.22, "height": 222.95999999999998},
        "position": {"x": 908, "y": -148},
        "width": 167,
        "height": 223,
        "positionAbsolute": {"x": 908, "y": -148},
        "selected": False,
        "dragging": False,
    },
    {
        "id": "13",
        "type": "promptNode",
        "data": {
            "nodeId": "13",
            "nodeName": "message-13",
            "nodePrompt": "say you didn't recognize user answer",
            "condition": {"properties": {"tag_name": "", "tag_id": ""}},
        },
        "style": {"width": 167.22, "height": 222.95999999999998},
        "position": {"x": 528, "y": -253.5},
        "width": 167,
        "height": 223,
        "selected": False,
        "positionAbsolute": {"x": 528, "y": -253.5},
        "dragging": False,
    },
]


ui_edges = [
    {
        "source": "0",
        "sourceHandle": None,
        "target": "1",
        "targetHandle": None,
        "id": "reactflow__edge-0-1",
    },
    {
        "source": "1",
        "sourceHandle": None,
        "target": "2",
        "targetHandle": None,
        "id": "reactflow__edge-1-2",
    },
    {
        "source": "2",
        "sourceHandle": None,
        "target": "3",
        "targetHandle": None,
        "id": "reactflow__edge-2-3",
    },
    {
        "source": "5",
        "sourceHandle": None,
        "target": "7",
        "targetHandle": None,
        "id": "reactflow__edge-5-7",
    },
    {
        "source": "6",
        "sourceHandle": None,
        "target": "10",
        "targetHandle": None,
        "id": "reactflow__edge-6-10",
    },
    {
        "source": "9",
        "sourceHandle": None,
        "target": "11",
        "targetHandle": None,
        "id": "reactflow__edge-9-11",
    },
    {
        "source": "8",
        "sourceHandle": None,
        "target": "12",
        "targetHandle": None,
        "id": "reactflow__edge-8-12",
    },
    {
        "source": "4",
        "sourceHandle": None,
        "target": "13",
        "targetHandle": None,
        "id": "reactflow__edge-4-13",
    },
]


expected_flow_graph = {
    "nodes": {
        "1": {
            "id": "1",
            "type": "promptNode",
            "edges": [{"source_node_id": "1", "target_node_id": "2"}],
            "content": "greet user",
        },
        "2": {
            "id": "2",
            "type": "promptNode",
            "edges": [{"source_node_id": "2", "target_node_id": "3"}],
            "content": "Ask user what he thinks about now",
        },
        "3": {
            "id": "3",
            "type": "conditionBlock",
            "edges": [
                {
                    "source_node_id": "3",
                    "target_node_id": "7",
                    "id": "5",
                    "condition": {
                        "type": "tag_detected",
                        "properties": {
                            "tag_name": "negative",
                            "tag_id": "5c3e8a6a-944a-4c66-97ed-599446202160",
                        },
                    },
                },
                {
                    "source_node_id": "3",
                    "target_node_id": "7",
                    "id": "5",
                    "condition": {
                        "type": "tag_detected",
                        "properties": {
                            "tag_name": "negative",
                            "tag_id": "5c3e8a6a-944a-4c66-97ed-599446202160",
                        },
                    },
                },
                {
                    "source_node_id": "3",
                    "target_node_id": "10",
                    "id": "6",
                    "condition": {
                        "type": "tag_detected",
                        "properties": {
                            "tag_name": "positive",
                            "tag_id": "e923a0fa-7cac-4715-9b5a-930b0611a71d",
                        },
                    },
                },
                {
                    "source_node_id": "3",
                    "target_node_id": "10",
                    "id": "6",
                    "condition": {
                        "type": "tag_detected",
                        "properties": {
                            "tag_name": "positive",
                            "tag_id": "e923a0fa-7cac-4715-9b5a-930b0611a71d",
                        },
                    },
                },
                {
                    "source_node_id": "3",
                    "target_node_id": "13",
                    "id": "4",
                    "condition": {
                        "type": "else",
                        "properties": {"tag_name": "", "tag_id": ""},
                    },
                },
                {
                    "source_node_id": "3",
                    "target_node_id": "13",
                    "id": "4",
                    "condition": {
                        "type": "else",
                        "properties": {"tag_name": "", "tag_id": ""},
                    },
                },
            ],
        },
        "7": {
            "id": "7",
            "type": "conditionBlock",
            "edges": [
                {
                    "source_node_id": "7",
                    "target_node_id": "11",
                    "id": "9",
                    "condition": {
                        "type": "tag_detected",
                        "properties": {
                            "tag_name": "unsubscribe",
                            "tag_id": "556c7040-3d43-44ef-b1e8-e4548c0f3c1d",
                        },
                    },
                },
                {
                    "source_node_id": "7",
                    "target_node_id": "11",
                    "id": "9",
                    "condition": {
                        "type": "tag_detected",
                        "properties": {
                            "tag_name": "unsubscribe",
                            "tag_id": "556c7040-3d43-44ef-b1e8-e4548c0f3c1d",
                        },
                    },
                },
                {
                    "source_node_id": "7",
                    "target_node_id": "12",
                    "id": "8",
                    "condition": {
                        "type": "else",
                        "properties": {"tag_name": "", "tag_id": ""},
                    },
                },
                {
                    "source_node_id": "7",
                    "target_node_id": "12",
                    "id": "8",
                    "condition": {
                        "type": "else",
                        "properties": {"tag_name": "", "tag_id": ""},
                    },
                },
            ],
        },
        "10": {
            "id": "10",
            "type": "promptNode",
            "edges": [],
            "content": "wish user a wonderful day and say bye",
        },
        "11": {
            "id": "11",
            "type": "promptNode",
            "edges": [],
            "content": "say user he was unsubscribed",
        },
        "12": {
            "id": "12",
            "type": "promptNode",
            "edges": [],
            "content": "say user bye",
        },
        "13": {
            "id": "13",
            "type": "promptNode",
            "edges": [],
            "content": "say you didn't recognize user answer",
        },
    },
    "source_node_id": "1",
}
